import numpy as np


menu_for_howtouse_eng = [
    {'Analysis': 'Kolmogorov-Smirnov Test',
        'Purpose': 'Check normality assumption',
        'method': 'kstest',
        'vars': 'Variable to check for normality assumptions (str)',
        'group_vars': np.nan,
        'posthoc': np.nan},
    {'Analysis': 'Shapiro-Wilks Test',
        'Purpose': 'Check normality assumption',
        'method': 'shapiro',  
        'vars': 'Variable to check for normality assumptions (str)',
        'group_vars': np.nan,
        'posthoc': np.nan},
    {'Analysis': 'z-skeweness & z-kurtosis test',
        'Purpose': 'Check normality assumption',
        'method': 'z_normal',
        'vars': 'Variable to check for normality assumptions (str)',
        'group_vars': np.nan,
        'posthoc': np.nan},
    {'Analysis': 'Levene Test',
        'Purpose': 'Check homoskedasticity assumption',
        'method': 'levene',
        'vars': 'Variable to check for homoskedasticity assumptions (str)',
        'group_vars': 'Group variable (str)',
        'posthoc': np.nan}, 
    {'Analysis': 'F-max Test',
        'Purpose': 'Check homoskedasticity assumption',
        'method': 'fmax',
        'vars': 'Variable to check for homoskedasticity assumptions (str)',
        'group_vars': 'Group variable (str)',
        'posthoc': np.nan},
    {'Analysis': 'Chi-Square Test',
        'Purpose': 'Cross-tabulation analysis',
        'method': 'chi2_contingency',
        'vars': 'Variables to check for frequency differences (list)',
        'group_vars': np.nan,
        'posthoc': np.nan},
    {'Analysis': "Fisher's Exact Test",
        'Purpose': 'Cross-tabulation analysis',
        'method': 'fisher',
        'vars': 'Variables to check for frequency differences (list)',
        'group_vars': np.nan,
        'posthoc': np.nan},
    {'Analysis': 'Correlation analysis: Pearson r',
        'Purpose': 'Correlation analysis - Parametric test',
        'method': 'pearsonr',
        'vars': 'Variables to check correlation (list)',
        'group_vars': np.nan,
        'posthoc': np.nan},
    {'Analysis': 'Correlation analysis: Spearman rho',
        'Purpose': 'Correlation analysis - Non-parametric test',
        'method': 'spearmanr',
        'vars': 'Variables to check correlation (list)',
        'group_vars': np.nan,
        'posthoc': np.nan},
    {'Analysis': "Correlation analysis: Kendall's tau-b",
        'Purpose': 'Correlation analysis - Non-parametric test',
        'method': 'kendallt',
        'vars': 'Variables to check correlation (list)',
        'group_vars': np.nan,
        'posthoc': np.nan},
    {'Analysis': 'Indenpendent Samples T-test',
        'Purpose': 'Compare between groups (two) - Parametric test',
        'method': 'ttest_ind',
        'vars': 'Dependent variable (str)',
        'group_vars': 'Group variable (str)',
        'posthoc': np.nan},
    {'Analysis': 'Dependent Samples T-test',
        'Purpose': 'Compare between times (two) - Parametric test',
        'method': 'ttest_rel',
        'vars': 'Dependent variables (list)',
        'group_vars': np.nan,
        'posthoc': np.nan}, 
    {'Analysis': 'Mann-Whitney U Test',
        'Purpose': 'Compare between groups (two) - Non-parametric test',
        'method': 'mannwhitneyu',
        'vars': 'Dependent variable (str)',
        'group_vars': 'Group variable (str)',
        'posthoc': np.nan},
    {'Analysis': 'Brunner-Munzel Test',
        'Purpose': 'Compare between groups (two) - Non-parametric test',
        'method': 'brunner',
        'vars': 'Dependent variable (str)',
        'group_vars': 'Group variable (str)',
        'posthoc': np.nan},
    {'Analysis': 'Wilcoxon-Signed Ranksum Test',
        'Purpose': 'Compare between times (two) - Non-parametric test',
        'method': 'wilcoxon',
        'vars': 'Dependent variables (list)',
        'group_vars': np.nan,
        'posthoc': np.nan},
    {'Analysis': 'Bootstrap Resampling (Resampling NO. = 1,000)',
        'Purpose': 'Retunring pandas.dataframe',
        'method': 'bootstrap1000_df',
        'vars': 'Variable (str) or variables (list) to resample',
        'group_vars': 'Group variable to proceed resampling on or omit',
        'posthoc': np.nan},
    {'Analysis': 'Bootstrap Resampling (Resampling NO. = 10,000)',
        'Purpose': 'Retunring pandas.dataframe',
        'method': 'bootstrap10000_df',
        'vars': 'Variable (str) or variables (list) to resample',
        'group_vars': 'Group variable to proceed resampling on or omit',
        'posthoc': np.nan},
    {'Analysis': 'Bootstrap percentile method: Resampling No. = 1,000',
        'Purpose': 'Compare between groups or between times',
        'method': 'bootstrap1000',
        'vars': 'Variable (str) or variables (list) to resample',
        'posthoc': np.nan},
    {'Analysis': 'Bootstrap percentile method: Resampling No. = 10,000',
        'Purpose': 'Compare between groups or between times',
        'method': 'bootstrap10000',
        'vars': 'Variable (str) or variables (list) to resample',
        'group_vars': 'Group variable to proceed resampling on or omit',
        'posthoc': np.nan},
    {'Analysis': 'One-way ANOVA',
        'Purpose': 'Compare between groups (more than two groups) - Parametric test',
        'method': 'f_oneway',
        'vars': 'Dependent variable (str)',
        'group_vars': 'Group variable (str)',
        'posthoc': 'True: Proceed the posthoc anaylsis'},
    {'Analysis': 'One-way Repeated Measures ANOVA',
        'Purpose': 'Compare between times (more than two times) - Parametric test',
        'method': 'f_oneway_rm',
        'vars': 'Dependent variables (list)',
        'group_vars': np.nan,
        'posthoc': 'True: Proceed the posthoc anaylsis'},
    {'Analysis': 'Kruskal-Wallis Test',
        'Purpose': 'Compare between groups (more than two groups) - Non-parametric test',
        'method': 'kruskal',
        'vars': 'Dependent variable (str)',
        'group_vars': 'Group variable (str)',
        'posthoc': 'True: Proceed the posthoc anaylsis'},
    {'Analysis': 'Friedman Test',
        'Purpose': 'Compare between times (more than two times) - Non-parametric test',
        'method': 'friedman',
        'vars': 'Dependent variables (list)',
        'group_vars': np.nan,
        'posthoc': 'True: Proceed the posthoc anaylsis'},
    {'Analysis': 'N-way ANOVA',
        'Purpose': 'Compare between factors - Parametric test',
        'method': 'f_nway',
        'vars': 'Dependent variable (str)',
        'group_vars': 'Group variables or factors (list)',
        'posthoc': 'True: Proceed the posthoc anaylsis'},
    {'Analysis': 'N-way Repeated Measures ANOVA',
        'Purpose': 'Compare between factors including time - Parametric test',
        'method': 'f_nway_rm',
        'vars': 'Dependent variables (list)',
        'group_vars': 'Group variables or factors (list)',
        'posthoc': 'True: Proceed the posthoc anaylsis'},
    {'Analysis': 'Linear Regression',
        'Purpose': 'Regression analysis',
        'method': 'linearr',
        'vars': "['dependent variable', ['independent variable1', 'independent variable2', ...., ] ]",
        'group_vars': np.nan,
        'posthoc': np.nan},
    {'Analysis': 'Logistic Regression',
        'Purpose': 'Regression analysis',
        'method': 'logisticr',
        'vars': "['dependent variable', ['independent variable1', 'independent variable2', ...., ] ]",
        'group_vars': np.nan,
        'posthoc': np.nan},
    {'Analysis': 'One-way ANCOVA',
        'Purpose': 'Compare between groups (more than two groups) - Parametric test',
        'method': 'oneway_ancova',
        'vars': "['dependent variable', ['covariate1', 'covariate2', ...., ] ]",
        'group_vars': 'Group variable (str)',
        'posthoc': 'True: Proceed the posthoc anaylsis'},
    {'Analysis': 'Repeated Measures ANCOVA',
        'Purpose': 'Compare between times (more than two times) - Parametric test',
        'method': 'rm_ancova',
        'vars': "['dependent variable1', 'dependent variable2', ... ['covariate1', 'covariate2', ...., ]]",
        'group_vars': np.nan,
        'posthoc': 'True: Proceed the posthoc anaylsis'},
    {'Analysis': 'N-way ANCOVA',
        'Purpose': 'Compare between factors - Parametric test',
        'method': 'nway_ancova',
        'vars': "['dependent variable', ['covariate1', 'covariate2', ...., ] ]",
        'group_vars': 'Group variables or factors (list)',
        'posthoc': 'True: Proceed the posthoc anaylsis'}
    ]



menu_for_howtouse_kor = {
                '목적': {'Kolmogorov-Smirnov Test': '정규성 검정',
                    'Shapiro-Wilks Test': '정규성 검정',
                    'z-skeweness & z-kurtosis test': '정규성 검정',
                    'Levene Test': '등분산성 검정',
                    'F-max Test': '등분산성 검정',
                    'Chi-Square Test': '빈도분석',
                    "Fisher's Exact Test": '빈도분석',
                    '상관분석: Pearson r': '상관분석-모수검정',
                    '상관분석: Spearman rho': '상관분석-비모수검정',
                    "상관분석: Kendall's tau-b": '상관분석-비모수검정',
                    'Indenpendent Samples T-test': '차이비교 (2집단)-모수검정',
                    'Dependent Samples T-test': '차이비교 (집단 내 2시점)-모수검정',
                    'Mann-Whitney U Test': '차이비교 (2집단)-비모수검정',
                    'Brunner-Munzel Test': '차이비교 (2집단)-비모수검정',
                    'Wilcoxon-Signed Ranksum Test': '차이비교 (집단 내 2시점)-비모수검정',
                    'Bootstrap Resampling (Resampling NO. = 1,000)': '데이터프레임 반환',
                    'Bootstrap Resampling (Resampling NO. = 10,000)': '데이터프레임 반환',
                    'Bootstrap percentile method: Resampling No. = 1,000': '차이비교 (2집단 or 2시점)',
                    'Bootstrap percentile method: Resampling No. = 10,000': '차이비교 (2집단 or 2시점)',
                    'One-way ANOVA': '차이비교 (3집단 이상)-모수검정',
                    'One-way Repeated Measures ANOVA': '차이비교 (집단 내 3시점 이상)-모수검정',
                    'Kruskal-Wallis Test': '차이비교 (3집단 이상)-비모수검정',
                    'Friedman Test': '차이비교 (집단 내 3시점 이상)-비모수검정',
                    'N-way ANOVA': '차이비교-모수검정',
                    'N-way Repeated Measures ANOVA': '차이비교-모수검정',
                    'Linear Regression': '회귀분석',
                    'Logistic Regression': '회귀분석',
                    'One-way ANCOVA' : '차이비교 (3집단 이상)-모수검정',
                    'Repeated Measures ANCOVA' : '차이비교 (집단 내 3시점 이상)-모수검정',
                    'N-way ANCOVA' : '차이비교-모수검정',
                    },
                'method': {'Kolmogorov-Smirnov Test': 'kstest',
                        'Shapiro-Wilks Test': 'shapiro',
                        'z-skeweness & z-kurtosis test': 'z_normal',
                        'Levene Test': 'levene',
                        'F-max Test': 'fmax',
                        'Chi-Square Test': 'chi2_contingency',
                        "Fisher's Exact Test": 'fisher',
                        '상관분석: Pearson r': 'pearsonr',
                        '상관분석: Spearman rho': 'spearmanr',
                        "상관분석: Kendall's tau-b": 'kendallt',
                        'Indenpendent Samples T-test': 'ttest_ind',
                        'Dependent Samples T-test': 'ttest_rel',
                        'Mann-Whitney U Test': 'mannwhitneyu',
                        'Brunner-Munzel Test': 'brunner',
                        'Wilcoxon-Signed Ranksum Test': 'wilcoxon',
                        'Bootstrap Resampling (Resampling NO. = 1,000)': 'bootstrap1000_df',
                        'Bootstrap Resampling (Resampling NO. = 10,000)': 'bootstrap10000_df',
                        'Bootstrap percentile method: Resampling No. = 1,000': 'bootstrap1000',
                        'Bootstrap percentile method: Resampling No. = 10,000': 'bootstrap10000',
                        'One-way ANOVA': 'f_oneway',
                        'One-way Repeated Measures ANOVA': 'f_oneway_rm',
                        'Kruskal-Wallis Test': 'kruskal',
                        'Friedman Test': 'friedman',
                        'N-way ANOVA': 'f_nway',
                        'N-way Repeated Measures ANOVA': 'f_nway_rm',
                        'Linear Regression': 'linearr',
                        'Logistic Regression': 'logisticr',
                        'One-way ANCOVA' : 'oneway_ancova',
                        'Repeated Measures ANCOVA' : 'rm_ancova',
                        'N-way ANCOVA' : 'nway_ancova',
                        
                        },
                'vars': {'Kolmogorov-Smirnov Test': '정규성을 검정할 변수 (str)',
                        'Shapiro-Wilks Test': '정규성을 검정할 변수 (str)',
                        'z-skeweness & z-kurtosis test': '정규성을 검정할 변수 (str)',
                        'Levene Test': '등분산성을 검정할 변수 (str)',
                        'F-max Test': '등분산성을 검정할 변수 (str)',
                        'Chi-Square Test': '빈도차이를 확인할 변수들 (list)',
                        "Fisher's Exact Test": '빈도차이를 확인할 변수들 (list)',
                        '상관분석: Pearson r': '상관관계를 확인할 변수들 (list)',
                        '상관분석: Spearman rho': '상관관계를 확인할 변수들 (list)',
                        "상관분석: Kendall's tau-b": '상관관계를 확인할 변수들 (list)',
                        'Indenpendent Samples T-test': '차이를 확인할 변수 (str)',
                        'Dependent Samples T-test': '차이를 확인할 변수들 (list)',
                        'Mann-Whitney U Test': '차이를 확인할 변수 (str)',
                        'Brunner-Munzel Test': '차이를 확인할 변수 (str)',
                        'Wilcoxon-Signed Ranksum Test': '차이를 확인할 변수들 (list)',
                        'Bootstrap Resampling (Resampling NO. = 1,000)': '리샘플링을 실시할 변수 (str) 혹은 샘플링을 실시할 변수들 (list)',
                        'Bootstrap Resampling (Resampling NO. = 10,000)': '리샘플링을 실시할 변수 (str) 혹은 샘플링을 실시할 변수들 (list)',
                        'Bootstrap percentile method: Resampling No. = 1,000': '리샘플링을 실시할 변수 (str) 혹은 샘플링을 실시할 변수들 (list)',
                        'Bootstrap percentile method: Resampling No. = 10,000': '리샘플링을 실시할 변수 (str) 혹은 샘플링을 실시할 변수들 (list)',
                        'One-way ANOVA': '차이를 확인할 변수 (str)',
                        'One-way Repeated Measures ANOVA': '차이를 확인할 변수들 (list)',
                        'Kruskal-Wallis Test': '차이를 확인할 변수 (str)',
                        'Friedman Test': '차이를 확인할 변수들 (list)',
                        'N-way ANOVA': '차이를 확인할 변수 (str)',
                        'N-way Repeated Measures ANOVA': '차이를 확인할 변수들 (list)',
                        'Linear Regression': "['종속변수', ['독립변수1', '독립변수2', ...., ] ]",
                        'Logistic Regression': "['종속변수', ['독립변수1', '독립변수2', ...., ] ]",
                        'One-way ANCOVA' : "['종속변수', ['공변량1', '공변량2', ...., ] ]",
                        'Repeated Measures ANCOVA' : "['종속변수1', '종속변수2', ... ['공변량1', '공변량2', ...., ]]",
                        'N-way ANCOVA' : "['종속변수', ['공변량1', '공변량2', ...., ] ]",                     
                        },
                'group_vars': {'Kolmogorov-Smirnov Test': np.nan,
                            'Shapiro-Wilks Test': np.nan,
                            'z-skeweness & z-kurtosis test': np.nan,
                            'Levene Test': '기준이 될 집단 변수 (str)',
                            'F-max Test': '기준이 될 집단 변수 (str)',
                            'Chi-Square Test': np.nan,
                            "Fisher's Exact Test": np.nan,
                            '상관분석: Pearson r': np.nan,
                            '상관분석: Spearman rho': np.nan,
                            "상관분석: Kendall's tau-b": np.nan,
                            'Indenpendent Samples T-test': '기준이 될 집단 변수 (str)',
                            'Dependent Samples T-test': np.nan,
                            'Mann-Whitney U Test': '기준이 될 집단 변수 (str)',
                            'Brunner-Munzel Test': '기준이 될 집단 변수 (str)',
                            'Wilcoxon-Signed Ranksum Test': np.nan,
                            'Bootstrap Resampling (Resampling NO. = 1,000)': '리샘플링의 기준이 될 집단 변수 혹은 생략',
                            'Bootstrap Resampling (Resampling NO. = 10,000)': '리샘플링의 기준이 될 집단 변수 혹은 생략',
                            'Bootstrap percentile method: Resampling No. = 1,000': '리샘플링의 기준이 될 집단 변수 혹은 생략',
                            'Bootstrap percentile method: Resampling No. = 10,000': '리샘플링의 기준이 될 집단 변수 혹은 생략',
                            'One-way ANOVA': '기준이 될 집단 변수 (str)',
                            'One-way Repeated Measures ANOVA': np.nan,
                            'Kruskal-Wallis Test': '기준이 될 집단 변수 (str)',
                            'Friedman Test': np.nan,
                            'N-way ANOVA': '기준이 될 집단 변수들 (list)',
                            'N-way Repeated Measures ANOVA': '기준이 될 집단 변수들 (list)',
                            'Linear Regression': np.nan,
                            'Logistic Regression': np.nan,
                            'One-way ANCOVA' : '기준이 될 집단 변수 (str)',
                            'Repeated Measures ANCOVA' : np.nan,
                            'N-way ANCOVA' : '기준이 될 집단 변수들 (list)',          
                            },
                'posthoc': {'Kolmogorov-Smirnov Test': np.nan,
                            'Shapiro-Wilks Test': np.nan,
                            'z-skeweness & z-kurtosis test': np.nan,
                            'Levene Test': np.nan,
                            'F-max Test': np.nan,
                            'Chi-Square Test': np.nan,
                            "Fisher's Exact Test": np.nan,
                            '상관분석: Pearson r': np.nan,
                            '상관분석: Spearman rho': np.nan,
                            "상관분석: Kendall's tau-b": np.nan,
                            'Indenpendent Samples T-test': np.nan,
                            'Dependent Samples T-test': np.nan,
                            'Mann-Whitney U Test': np.nan,
                            'Brunner-Munzel Test': np.nan,
                            'Wilcoxon-Signed Ranksum Test': np.nan,
                            'Bootstrap Resampling (Resampling NO. = 1,000)': np.nan,
                            'Bootstrap Resampling (Resampling NO. = 10,000)': np.nan,
                            'Bootstrap percentile method: Resampling No. = 1,000': np.nan,
                            'Bootstrap percentile method: Resampling No. = 10,000': np.nan,
                            'One-way ANOVA': 'True: posthoc 진행',
                            'One-way Repeated Measures ANOVA': 'True: posthoc 진행',
                            'Kruskal-Wallis Test': 'True: posthoc 진행',
                            'Friedman Test': 'True: posthoc 진행',
                            'N-way ANOVA': 'True: posthoc 진행',
                            'N-way Repeated Measures ANOVA': 'True: posthoc 진행',
                            'Linear Regression': np.nan,
                            'Logistic Regression': np.nan,
                            'One-way ANCOVA' : 'True: posthoc 진행',
                            'Repeated Measures ANCOVA' : 'True: posthoc 진행',
                            'N-way ANCOVA' : 'True: posthoc 진행',         
                            }}            
selector_for_howtouse_kor = {
    'python 식': {
        0: 'if a == b:',
        1: 'if a != b:',
        2: 'if a > b:',
        3: 'if a >= b:',
        4: 'if a < b:',
        5: 'if a <= b:'
        },
    '의미': {
        0: 'a가 b인 데이터만',
        1: 'a가 b가 아닌 데이터만',
        2: 'a가 b 초과인 데이터만',
        3: 'a가 b 이상인 데이터만',
        4: 'a가 b 미만인 데이터만',
        5: 'a가 b 이하인 데이터만'
        },
    'selector 인자 형식': {
        0: "{'a' : 'b'}",
        1: "{'a' : {'!=', 'b'} }",
        2: "{'a' : {'>', 'b'} }",
        3: "{'a' : {'>=', 'b'} }",
        4: "{'a' : {'<', 'b'} }",
        5: "{'a' : {'<=', 'b'} }"
        },
    'pandas 식': {
        0: "df.loc['a' == 'b']",
        1: "df.loc['a' != 'b']",
        2: "df.loc['a' > 'b']",
        3: "df.loc['a' >= 'b']",
        4: "df.loc['a' < 'b']",
        5: "df.loc['a' <= 'b']"
        }
    }

selector_for_howtouse_eng = {
    'python operator': {
        0: 'if a == b:',
        1: 'if a != b:',
        2: 'if a > b:',
        3: 'if a >= b:',
        4: 'if a < b:',
        5: 'if a <= b:'
        },
    'mean': {
        0: 'Only the data where a is b',
        1: 'Only the data where a is NOT b',
        2: 'Only the data with a > b',
        3: 'Only the data with a >= b',
        4: 'Only the data with a < b',
        5: 'Only the data with a <= b'
        },
    'format of selector argument': {
        0: "{'a' : 'b'}",
        1: "{'a' : {'!=', 'b'} }",
        2: "{'a' : {'>', 'b'} }",
        3: "{'a' : {'>=', 'b'} }",
        4: "{'a' : {'<', 'b'} }",
        5: "{'a' : {'<=', 'b'} }"
        },
    'pandas operator': {
        0: "df.loc['a' == 'b']",
        1: "df.loc['a' != 'b']",
        2: "df.loc['a' > 'b']",
        3: "df.loc['a' >= 'b']",
        4: "df.loc['a' < 'b']",
        5: "df.loc['a' <= 'b']"
        }
    }